# Copyright (c) 2019-2020, NVIDIA CORPORATION. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#  * Neither the name of NVIDIA CORPORATION nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# specific version required for protobuf
if(NOT PROTOBUF_FOUND AND NOT Protobuf_FOUND)
  set(protobuf_MODULE_COMPATIBLE TRUE CACHE BOOL "protobuf_MODULE_COMPATIBLE" FORCE)
  find_package(Protobuf 3.12.3.0 CONFIG REQUIRED)
endif()

# specific version required for grpc
if(NOT GRPC_FOUND AND NOT gRPC_FOUND)
  find_package(gRPC 1.35.0 CONFIG REQUIRED)
endif()

if(NOT CURL_FOUND)
  if(${TRITON_CURL_WITHOUT_CONFIG})
    find_package(CURL REQUIRED)
  else()
    find_package(CURL CONFIG REQUIRED)
  endif() # TRITON_CURL_WITHOUT_CONFIG
endif()

if(NOT Threads_FOUND)
  find_package(Threads REQUIRED)
endif()

if (NOT (TARGET TRITON::grpcclient OR TARGET TRITON::httpclient))
  include ("${CMAKE_CURRENT_LIST_DIR}/TRITONTargets.cmake")
endif ()
